__device__ void rule(short * row, short * old_row, int x)
{
	row[x] = old_row[x-1] ^ old_row[x+1];
}

__global__ void kernel(float4* pos, short * row, short * old_row, unsigned int max, unsigned int y)
{
    unsigned int x = blockIdx.x*blockDim.x + threadIdx.x;

    if(x < max)
    {
	rule(row, old_row, y);
	if(row[x])
		pos[y*max+x] = make_float4(0, 0, 255, 0.0f);
	else
		pos[y*max+x] = make_float4(x/2, y/2, 0, 1);
    }
}
